<?php

namespace Ulmus\Ldap\Entity;

use Ulmus\Ldap\Entity\Field\{ Datetime };

/**
 * @ObjectClass('user')
 */
class User
{
    use \Ulmus\Ldap\EntityTrait;

    /**
     * @Field
     */
    public string $samaccountname;

    /**
     * @Field
     */
    public string $mail;

    /**
     * @Field
     */
    public string $mailNickname;

    /**
     * @Field('name' => 'givenname')
     */
    public string $firstname;

    /**
     * @Field('name' => 'sn')
     */
    public string $lastname;

    /**
     * @Field
     */
    public string $displayName;

    /**
     * @Field
     */
    public string $name;

    /**
     * @Field
     */
    public string $userPrincipalName;

    /**
     * @Field
     */
    public string $description;

    /**
     * @Field('name' => "st")
     */
    public string $state;

    /**
     * @Field('name' => 'physicalDeliveryOfficeName')
     */
    public string $officeName;

    /**
     * @Field
     */
    public string $company;

    /**
     * @Field
     */
    public string $department;

    /**
     * @Field
     */
    public string $title;

    /**
     * @Field
     */
    public string $userAccountControl;

    /**
     * @Field
     */
    public string $extensionAttribute1;

    /**
     * @Field
     */
    public string $extensionAttribute2;

    /**
     * @Field
     */
    public string $extensionAttribute3;

    /**
     * @Field
     */
    public string $extensionAttribute4;

    /**
     * @Field
     */
    public int $logonCount;

    /**
     * @Field('name' => 'unicodePwd')
     */
    public string $unicodePassword;

    /**
     * @Field
     */
    public string $userPassword;

    /**
     * @Field
     */
    public Datetime $lastLogonDate;

    /**
     * #Field('name' => 'createTimeStamp')
     */
    # public Datetime $createdAt;

    /**
     * #Field('name' => 'modifyTimeStamp')
     */
    # public Datetime $updatedAt;

    public function __toString() : string
    {
        return implode(' ', array_filter([ $this->firstname ?? "", $this->lastname ?? "" ])) ?: $this->displayName;
    }
}