<?php

namespace Ulmus\Ldap\Query;

class Select extends \Ulmus\Query\Fragment {

    public bool $distinct = false;

    public bool $union = false;

    public ? int $top = null;

    protected array $fields = [];

    public function set($fields) : self
    {
        $this->fields = is_array($fields) ? $fields : [ $fields ];

        return $this;
    }

    public function add($fields) : self
    {
        if ( is_array($fields) ) {
            $this->fields = array_merge($this->fields, $fields);
        }
        else {
            $this->fields[] = $fields;
        }

        return $this;
    }

    public function render() : array
    {
        return [
            'fields' => $this->fields
        ];
    }
}
